void InitializeMIDI(boolean actionFlag)
{
  //MidiBus.list(); //list all inputs and outputs
  // println(MidiBus.availableInputs()); //list just inputs

  //actionFlag = true, load from MIDIControl Port, False is it being enabled and display buttons
  try
  {  
    //  MidiBus.close();
  }
  catch(Exception e) {
  }

  if (actionFlag == true)
  {
    try
    {
      myBus = new MidiBus(this, Matrix.softwareMIDIport, 0); // Create a new MidiBus using the device index to select the Midi input and output devices respectively.
      println("Using MIDI Device: "+myBus);
    }
    catch(Exception e)
    {
      println("Cannot Connect To Specified MIDI Device, Check config.ini");
    }
  }//end if
  else
  {
    int tXpos = cTempGUI2X;//GUIMenus[2].xpos;//main menu location
    int tYpos = cTempGUI2Y;//GUIMenus[2].ypos;

    MIDIMenuButtons = new Button[MidiBus.availableInputs().length];
    for (int i = 0; i != MidiBus.availableInputs().length;i++)
    {
      MIDIMenuButtons[i] = new Button("MIDI IN "+i, round((410+tXpos)*SF), round((80+tYpos)*SF), round(70*SF), round(20*SF), color(200), ColButtonsHL, color(0), true, false, false);
    }//end for()
  }
}

// ============================== START MIDI ====================================================

void noteOn(int channel, int pitch, int velocity) 
{
  // Receive a noteOn
  println();
  println("Note On:");
  println("--------");
  println("Channel:"+channel);
  println("Pitch:"+pitch);
  //  println("Velocity:"+velocity);

  MIDInumber = pitch; 
  HandleMIDINO = true;
}


void HandleNoteOn()
{
  HandleMIDINO = false;
  switch(MIDInumber)
  {
  case 4://A - color max
    HandleFeedAButtons(7);
    break;
  case 5://B - Color Max
    HandleFeedBButtons(7);  
    break;    
  case 6://A - color scale
    HandleFeedAButtons(9);    
    break;
  case 7://B - Color Scale
    HandleFeedBButtons(9);  
    break;     
  case 8://A - tint
    HandleFeedAButtons(6);
    break;
  case 9://B - tint
    HandleFeedBButtons(6);  
    break;     
  case 10:
    HandleCommonButtons(0); //Hard Cut A
    break;    
  case 11:
    HandleCommonButtons(1); //Hard Cut B
    break;
  case 12:
    HandleQuickAButtons(0);
    break;
  case 13:
    HandleQuickBButtons(0);
    break; 
  case 14:
    HandleQuickAButtons(1);
    break;  
  case 15:
    HandleQuickBButtons(1);
    break;    
  case 16:
    HandleQuickAButtons(2);
    break;  
  case 17:
    HandleQuickBButtons(2);
    break;    
  case 18:
    HandleQuickAButtons(3);
    break; 
  case 19:
    HandleQuickBButtons(3);
    break;    
  case 20:
    HandleQuickAButtons(4);
    break; 
  case 21:
    HandleQuickBButtons(4);
    break;    
  case 22:
    HandleQuickAButtons(5);
    break;  
  case 23:
    HandleQuickBButtons(5);
    break;   
  case 24:
    HandleQuickAButtons(6);
    break;  
  case 25:
    HandleQuickBButtons(6);
    break;    
  case 26:
    HandleQuickAButtons(7);
    break;
  case 27:
    HandleQuickBButtons(7);
    break;    
  case 28:
    HandleQuickAButtons(8);
    break; 
  case 29:
    HandleQuickBButtons(8);
    break;    
  case 30:
    HandleBlendButtons(0); //blend
    break; 
  case 31:
    HandleBlendButtons(4); ///Maxim
    break;    
  case 32:
    HandleBlendButtons(3); ///minim
    break;
  }
}//end func

void noteOff(int channel, int pitch, int velocity) {
  // Receive a noteOff
  println();
  println("Note Off:");
  println("--------");
  println("Channel:"+channel);
  println("Pitch:"+pitch);
  println("Velocity:"+velocity);
}

void controllerChange(int channel, int number, int value) {
  // Receive a controllerChange
  //Knobs don't send a location they send an increment or deincrement with a value 1 or more
  //    so the cases with if/else on Sliders values is modifying them and check for minimum or maximum
  println();
  println("Controller Change:");
  println("--------");
  println("Channel:"+channel);
  println("Number:"+number);
  println("Value:"+value);
//Running the redraw functions from here caused graphical glitches, saving the data and running it during draw() worked correctly
  MIDIchan = channel;
  MIDInumber = number; 
  MIDIvalue = value;
  HandleMIDICC = true;
}

void HandleControlChange()
{
  //Running the redraw functions from above event handler caused graphical glitches, saving the data and running it during draw() worked correctly
  int value = MIDIvalue;
  HandleMIDICC = false;
  
  switch(MIDInumber)//number)
  {
  case 9: //FeedB Red
   CommonSliders[3].selectSlider();
   SelectedSlider = 3;
    if (value < 64)  CommonSliders[3].setValue(CommonSliders[3].Value+value);
    else CommonSliders[3].setValue(CommonSliders[3].Value-(128-value));
    break;

  case 6://FeedB Green
   CommonSliders[4].selectSlider();
   SelectedSlider = 4;
    if (value < 64) CommonSliders[4].setValue(CommonSliders[4].Value+value); //CW rotation 
    else  CommonSliders[4].setValue(CommonSliders[4].Value-(128-value)); //CCW
    break;

  case 7://FeedB Blue
   CommonSliders[5].selectSlider();
    if (value < 64) CommonSliders[5].setValue(CommonSliders[5].Value+value);  //CW rotation 
    else CommonSliders[5].setValue(CommonSliders[5].Value-(128-value)); //CCW
    break;

  case 1: //FeedB Speed
   CommonSliders[7].selectSlider();
   SelectedSlider = 7;
    if (value < 64)  CommonSliders[7].setValue(CommonSliders[7].Value+value); //CW rotation 
    else  CommonSliders[7].setValue(CommonSliders[7].Value-(128-value)); //CCW
    break; 
    //=================================   

  case 10: //intesityA
    IntensitySliderA.selectSlider();
    IntensitySliderA.setValue(round(((float)value/127 ) * 100));
    break;

  case 11: //intesityB
    IntensitySliderB.selectSlider();
    IntensitySliderB.setValue(round(((float)value/127 ) * 100));
    break;

  case 12: //mixer
    MainMixerSlider.selectSlider();
    MainMixerSlider.setValue(round(( (float)value / 127) * 100));
    break;

  case 8: //FeedA Red
   CommonSliders[0].selectSlider();
   SelectedSlider = 0;
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[0].setValue(CommonSliders[0].Value+value);
    }
    else
    {
      CommonSliders[0].setValue(CommonSliders[0].Value-(128-value));
    }
    break;
  case 4://FeedA Green
   CommonSliders[1].selectSlider();
   SelectedSlider = 1;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[1].setValue(CommonSliders[1].Value+value);
    }
    else
    {
      CommonSliders[1].setValue(CommonSliders[1].Value-(128-value));
    }
    break;

  case 5://FeedA Blue
   CommonSliders[2].selectSlider();
   SelectedSlider = 2;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[2].setValue(CommonSliders[2].Value+value);
    }
    else
    {
      CommonSliders[2].setValue(CommonSliders[2].Value-(128-value));
    }
    break;

  case 0: //FeedA Speed
   CommonSliders[6].selectSlider();
   SelectedSlider = 6;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[6].setValue(CommonSliders[6].Value+value);
    }
    else
    {
      CommonSliders[6].setValue(CommonSliders[6].Value-(128-value));
    }
    break;
  }//end switch
  HandleSliders(false);
}//end func

//====================== START SERIAL CONTROL ===============

void HandleSerialCmd()
{
  HandleSerialFlag = false;  

  for (int i = 0; i != 12;i++)
  {
    //check against previous, if not equal run the switch if not continue
    if (PrevReceivedSerialControl[i] != ReceivedSerialControl[i])
    {
      int value = ReceivedSerialControl[i];
      println("Updating from DMX: "+i);
      switch(i)
      {
      case 0: //Mixer
        controllerChange(0, 12, round((ReceivedSerialControl[i]/2)));
        break;
      case 1://intensity
        controllerChange(0, 10, round((ReceivedSerialControl[i]/2))); 
        break;
      case 2: //FeedA Quick
        if (ReceivedSerialControl[i] >= QuickAButtons.length) ReceivedSerialControl[i] = QuickAButtons.length -1;   
        HandleQuickAButtons(ReceivedSerialControl[i]);
        break;
      case 3: //FeedB Quick
        if (ReceivedSerialControl[i] >= QuickBButtons.length) ReceivedSerialControl[i] = QuickBButtons.length -1;   
        HandleQuickBButtons(ReceivedSerialControl[i]);
        break;
      case 4: //FeedA Color Mode
        //None, invert, tint, color max, color scale

        //reset to all off, then turn on the correct one rather than figuring out toggling
        FeedAButtons[5].Selected = false; //make sure invert turns off  
        FeedAButtons[6].Selected = false; //make sure invert turns off  
        FeedAButtons[7].Selected = false; //make sure invert turns off  
        FeedAButtons[9].Selected = false; //make sure invert turns off  
        QuickFeeds[FeedASelQuick].ColorState = 0;
        QuickFeeds[FeedASelQuick].EffectState = 0;

        if (ReceivedSerialControl[i] == 1) HandleFeedAButtons(5); 
        else if (ReceivedSerialControl[i] == 2) HandleFeedAButtons(6);  
        else if (ReceivedSerialControl[i] == 3) HandleFeedAButtons(7);  
        else if (ReceivedSerialControl[i] == 4) HandleFeedAButtons(9);  

        //   SetColorStateFunc(Button[] b, int effectNum)   
        break;
      case 5: //FeedB Color Mode
        //None, invert, tint, color max, color scale

        //reset to all off, then turn on the correct one rather than figuring out toggling
        FeedBButtons[5].Selected = false; //make sure invert turns off  
        FeedBButtons[6].Selected = false; //make sure invert turns off  
        FeedBButtons[7].Selected = false; //make sure invert turns off  
        FeedBButtons[9].Selected = false; //make sure invert turns off  
        QuickFeeds[FeedBSelQuick].ColorState = 0;
        QuickFeeds[FeedBSelQuick].EffectState = 0;

        if (ReceivedSerialControl[i] == 1) HandleFeedBButtons(5); 
        else if (ReceivedSerialControl[i] == 2) HandleFeedBButtons(6);  
        else if (ReceivedSerialControl[i] == 3) HandleFeedBButtons(7);  
        else if (ReceivedSerialControl[i] == 4) HandleFeedBButtons(9);      
        break;
      case 6: //FeedA Red
        //Knobs work different from this
        CommonSliders[0].Value = value; 
        break;               
      case 7: //FeedA Green
        CommonSliders[1].Value = value; 
        break;         
      case 8: //FeedA Blue
        CommonSliders[2].Value = value; 
        break; 
      case 9: //FeedB Red
        CommonSliders[3].Value = value;  
        break;               
      case 10: //FeedB Green
        CommonSliders[4].Value = value;    
        break;         
      case 11: //FeedB Blue
        CommonSliders[5].Value = value; 
        break;
      }//end switch  
      UpdateWorkspace = true;
    }//end Prev If
  }//end for   

  for (int i = 0; i != 12;i++) PrevReceivedSerialControl[i] = ReceivedSerialControl[i]; //update Prev Registers
} //end func

