void PreviewColorEffects(int PassedID)
{
 //apply color effects to CachedThumbnail buffer so the original thumbnail is not overwritten, prevents the need to 
 //    regenerate the preview when color effects are changed
  
    PreviewBuffer.loadPixels();
    for (int i=0; i != (MatrixHeight * MatrixWidth);i++)
   { 
    switch(QuickFeeds[PassedID].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
        myColor = PreviewBuffer.pixels[i];    
        myRed = (myColor >> 16 & 0xFF) +QuickFeeds[PassedID].SliderRed;
        if(myRed > 255) myRed = 255;
        myGreen = (myColor >> 8 & 0xFF) + QuickFeeds[PassedID].SliderGreen;
        if(myGreen > 255) myGreen = 255; 
        myBlue = (myColor & 0xFF) + QuickFeeds[PassedID].SliderBlue;
        if(myBlue > 255) myBlue = 255;     
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);
      break; 
    case 2: //Color Maximum
      //if value is greater than color Maximium, Make it color Maximum
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
        
        if(myRed > QuickFeeds[PassedID].SliderRed) myRed =  QuickFeeds[PassedID].SliderRed;      
        if(myGreen > QuickFeeds[PassedID].SliderGreen) myGreen = QuickFeeds[PassedID].SliderGreen; 
        if(myBlue > QuickFeeds[PassedID].SliderBlue) myBlue = QuickFeeds[PassedID].SliderBlue;          
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);      
      break;
    case 3: //Color Scale
      //scale colors linearly based on sliders  
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
        
        myRed =  round(myRed * ((float)QuickFeeds[PassedID].SliderRed / 255));     
        myGreen = round(myGreen * ((float)QuickFeeds[PassedID].SliderGreen / 255));  
        myBlue = round(myBlue * ((float)QuickFeeds[PassedID].SliderBlue / 255));            
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);          
      break;    
    case 4: //Color Minim
        //if color is not at least the value of the slider, it is turned to 0
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
   
        if(myRed < QuickFeeds[PassedID].SliderRed) myRed =  0;      
        if(myGreen < QuickFeeds[PassedID].SliderGreen) myGreen = 0; 
        if(myBlue < QuickFeeds[PassedID].SliderBlue) myBlue = 0;          
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);         
      break;           
    } //end switch
    
     switch(QuickFeeds[FeedASelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferA[i] = 255 - BufferA[i];
      break;
    case 2: //contrast
      
      break;
    case 3: //invert and contrast

      break;  
      
    } //end switch        
  }//end for()
   PreviewBuffer.updatePixels();
      
}//end func

void MixFeeds()
{

//Color Effects ->  Apply Effects -> Individual FeedIntensity -> Blend

  for (int i=0; i != PatchedChannels;i++)
  { 
    switch(QuickFeeds[FeedASelQuick].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
      switch(i%3)
      {  
      case 0:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderRed; //red
        if (BufferA[i] > 255) BufferA[i] = 255;
        break;
      case 1:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderGreen; //green
        if (BufferA[i] > 255) BufferA[i] = 255; 
        break;
      case 2:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderBlue; //blue
        if (BufferA[i] > 255) BufferA[i] = 255; 
        break;
      }//end switch
      break; 
    case 2:  //Color Maximum
      //if value is greater than FilterValue, Make it FilterValue
      switch(i%3)
      {
      case 0:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderRed) BufferA[i] = QuickFeeds[FeedASelQuick].SliderRed; //red
        break;
      case 1:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderGreen) BufferA[i] = QuickFeeds[FeedASelQuick].SliderGreen;  //green
        break;
      case 2:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderBlue) BufferA[i] = QuickFeeds[FeedASelQuick].SliderBlue;  //blue
        break;
      }//end switch
      break;
    case 3: //Color Scale
      //scale colors based on sliders
      switch(i%3)
      {
      case 0:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderRed / 255)); //red
        break;
      case 1:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderGreen / 255));  //green
        break;
      case 2:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderBlue / 255));  //blue
        break;
      }//end switch    
      break;    
   case 4: //Color Minim     
  //if color is not at least the value of the slider make it 0 
  switch(i%3)
      {
      case 0:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderRed) BufferA[i] = 0;
        break;
      case 1:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderGreen) BufferA[i] = 0;
        break;
      case 2:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderBlue) BufferA[i] = 0;
        break;
      }
      break;
    } //end switch
    
     switch(QuickFeeds[FeedASelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferA[i] = 255 - BufferA[i];
      break;
    case 2: //contrast
    if(BufferA[i] < QuickFeeds[FeedASelQuick].ContrastValue) BufferA[i] = 0;
      break;    
    case 3: //invert + contrast
      BufferA[i] = 255 - BufferA[i];  
      if(BufferA[i] < QuickFeeds[FeedASelQuick].ContrastValue) BufferA[i] = 0;
      break;        
    } //end switch        
    
    /// ================= END A ========= START B =========================
    
    switch(QuickFeeds[FeedBSelQuick].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
      switch(i%3)
      {  
      case 0:
        BufferB[i] = BufferB[i] + CommonSliders[3].Value; //red
        if (BufferB[i] > 255) BufferB[i] = 255;
        break;
      case 1:
        BufferB[i] = BufferB[i] + CommonSliders[4].Value; //green
        if (BufferB[i] > 255) BufferB[i] = 255; 
        break;
      case 2:
        BufferB[i] = BufferB[i] + CommonSliders[5].Value; //blue
        if (BufferB[i] > 255) BufferB[i] = 255; 
        break;  
      }//end switch
      break; 
    case 2:  //Color Maximum
      //if value is greater than FilterValue, Make it FilterValue
      switch(i%3)
      {
      case 0:
        if (BufferB[i] > CommonSliders[3].Value) BufferB[i] = CommonSliders[3].Value; //red
        break;
      case 1:
        if (BufferB[i] > CommonSliders[4].Value) BufferB[i] = CommonSliders[4].Value;  //green
        break;
      case 2:
        if (BufferB[i] > CommonSliders[5].Value) BufferB[i] = CommonSliders[5].Value;  //blue
        break;
      }//end switch
      break;
    case 3: //Color Scale
      //scale colors based on sliders
      switch(i%3)
      {
      case 0:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[3].Value / 255)); //red
        break;
      case 1:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[4].Value / 255));  //green
        break;
      case 2:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[5].Value / 255));  //blue
        break;
      }//end switch    
      break;          
      
    } //end switch
    
     switch(QuickFeeds[FeedBSelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferB[i] = 255 - BufferB[i];
      break;
    case 2: //contrast
    if(BufferB[i] < QuickFeeds[FeedBSelQuick].ContrastValue) BufferB[i] = 0;
      break;    
    case 3: //invert + contrast
      BufferB[i] = 255 - BufferB[i];  
      if(BufferB[i] < QuickFeeds[FeedBSelQuick].ContrastValue) BufferB[i] = 0;
      break;        
    } //end switch     
  }//end for

//Intensity Second
if(LockIntensity == false) //if not locked, do individualy, otherwise perform on MixedBuffer Last
{
if(IntensityValueA != 1) for (int i=0; i != PatchedChannels ;i++)  BufferA[i] = round(BufferA[i] * IntensityValueA);
if(IntensityValueB != 1) for (int i=0; i != PatchedChannels ;i++)  BufferB[i] = round(BufferB[i] * IntensityValueB);
}
 /* 
   if(MixerValue == 0)
   {
   //   println("Mixer = 0");
   for(int i=0; i != MixedBuffer.length;i++)  MixedBuffer[i] = BufferA[i];
   return;
   }
   else if(MixerValue == 1)
   {
   //   println("Mixer = 1");
   for(int i=0; i != MixedBuffer.length;i++)  MixedBuffer[i] = BufferB[i];
   return;
   }
*/

//Blend Modes and feed mixing Third
switch(BlendingMode)
{
  case 0:
  //normal blend, works!
  for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round((((float)BufferA[i] * (1-MixerValue)) +  (((float)BufferB[i]) * MixerValue)));
  break; 
  case 1://overlay A to B
   for (int i=0; i != PatchedChannels ;i++)  
   {
  //  MixedBuffer[i] = ((BufferB[i] - BufferA[i]) < 0) ?  (BufferB[i] - BufferA[i])*-1 : (BufferB[i] - BufferA[i]);
    MixedBuffer[i] = ((round(BufferB[i]*MixerValue) - BufferA[i]) < 0) ?  (round(BufferB[i]*MixerValue) - BufferA[i])*-1 : (round(BufferB[i]*MixerValue));// - BufferA[i]);

   }
  break;
  case 2://overlay B to A
   for (int i=0; i != PatchedChannels ;i++)  
   {
    MixedBuffer[i] = ((round(BufferA[i]*(1-MixerValue)) - BufferB[i]) < 0) ?  (round(BufferA[i]*MixerValue) - BufferB[i])*-1 : (round(BufferA[i]*(1-MixerValue)));// - BufferA[i]);
//   MixedBuffer[i] = (BufferA[i] < BufferB[i]) ? round((float)BufferA[i] * (1-MixerValue)) : BufferB[i];
   }
  break; 
  case 3://min
//    for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = min(BufferA[i], BufferB[i]); //Orig, not controllable
    for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = min(round(BufferA[i] * MixerValue), BufferB[i]);//doesn't matter which one is calculated ends up the same
  break;
  case 4://max
 //   for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = max(BufferA[i], BufferB[i]);
      for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = max(round(BufferA[i] * MixerValue), BufferB[i]);
  break;
  case 5://add A to B
  //  for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferB[i]-BufferA[i]) * MixerValue, 0)); //max(B - A*factor, 0)
    for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferB[i]-BufferA[i]) * MixerValue, BufferA[i])); //max(B - A*factor, 0)  

  break; 
   case 6://add B to A
   // for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferA[i]-BufferB[i]) * MixerValue, 0)); //max(B - A*factor, 0)
   for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferA[i]-BufferB[i]) * MixerValue, BufferB[i])); //max(B - A*factor, 0)   

  break;  
}//end switch

if(LockIntensity == true)//if locked, do Intensity calculations once instead of on each Feed Buffer
{
  if(IntensityValueA != 1) for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(MixedBuffer[i] * IntensityValueA);
}
  
  /*  
   //kind of cool, not really a normal one to my knowledge
   for(int i=0; i != MixedBuffer.length;i++)
   {
   MixedBuffer[i] = round(255 - (((float)BufferA[i] * (1-MixerValue))) + (255 - ((float)BufferB[i] * MixerValue)));
   if(MixedBuffer[i] > 255) MixedBuffer[i] = MixedBuffer[i] - 255;
   }
   
   
  BLEND - linear interpolation of colours: C = A*factor + B. This is the default blending mode.
   
   ADD - additive blending with white clip: C = min(A*factor + B, 255)
   
   SUBTRACT - subtractive blending with black clip: C = max(B - A*factor, 0)
   
   DARKEST - only the darkest colour succeeds: C = min(A*factor, B)
   
   LIGHTEST - only the lightest colour succeeds: C = max(A*factor, B)
   
   DIFFERENCE - subtract colors from underlying image.
   
   EXCLUSION - similar to DIFFERENCE, but less extreme.
   
   MULTIPLY - multiply the colors, result will always be darker.
   
   SCREEN - opposite multiply, uses inverse values of the colors.
   
   REPLACE - the pixels entirely replace the others and don't utilize alpha (transparency) values
   */
} //end Func




void PackPixels(Movie m, QuickFeed f)
{
  // loadPixels();
  int Rows = m.height;//((myMovie.height - ActualRows) - myMovie.height)* -1;
  int Columns = m.width;  
  int RowDiff = 0;
  int ColumnDiff = 0;
  
  if(f.Method != 1)//if not Capture, capture adjusts the display so edges can be cropped
  {
  RowDiff = f.OffsetY; // m.height +
  ColumnDiff =  f.OffsetX; //m.width +
  }

//println(m.height+" : "+m.width);
//  println("Rows: "+Rows+" Columns: "+Columns+" RowDiff: "+RowDiff);//+" Pixels Length: "+pixels.length);

  int x = 0;
  int LocationX;
  int LocationY;

  //each PatchCoord Represents a pixel not a channel
  for (int i=0; i != MaxPixels;i++)
  {
    //int Location = ((PatchCoordY[i] + RowDiff) * Columns) + PatchCoordX[i]; //for use with get() pixels
    //println(PatchCoordX[i]+" : "+PatchCoordY[i]);
    //color myColor = pixels[Location];
    //println("Location: "+Location);

    LocationX = PatchCoordX[i]+ ColumnDiff;
    LocationY = (PatchCoordY[i] + RowDiff);
    
    if(f.Method == 0) 
    {
      try {
        myColor = m.get(LocationX, LocationY);
      }
      catch(Exception e) {
       println("Method 0 get() error"); 
       myColor = color(0);
      }
  }
  else 
  {   
      try
      {
         if(m ==myMovieA) myColor = GraphicsBufferA.get(LocationX, LocationY); 
         else myColor = GraphicsBufferB.get(LocationX, LocationY); 
      }
      catch(Exception e)
      {
      TestBars.resize(MatrixWidth, MatrixHeight);
       myColor = TestBars.get(LocationX, LocationY);
      }      
   }
        
    myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
    myGreen = myColor >> 8 & 0xFF;
    myBlue = myColor & 0xFF; 

    if (m == myMovieA)
    {
      BufferA[x] = (int)myRed;
      BufferA[x+1] = (int)myGreen;
      BufferA[x+2] = (int)myBlue;
    }
    else
    {
      BufferB[x] = (int)myRed;
      BufferB[x+1] = (int)myGreen;
      BufferB[x+2] = (int)myBlue;
    }
    x = x+3; 
  }//end for
  //println("--------------------------------------");
}//end func


